﻿using System;
using System.Collections.ObjectModel;
using System.Drawing;
using System.IO;
using System.Text;
using System.Windows.Forms;
using ThinkGeo.MapSuite.Core;
using ThinkGeo.MapSuite.DesktopEdition;

namespace Post9112
{
    public partial class Form1 : Form
    {
        private string geometryColumnName = "GEOM";

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            winformsMap1.MapUnit = GeographyUnit.DecimalDegree;


            LayerOverlay layerOverlay = new LayerOverlay();

            var tiffLayer = new GdiPlusRasterLayer(@"..\..\AppData\export.tif", @"..\..\AppData\export.tfw");
            layerOverlay.Layers.Add(tiffLayer);

            var shapeFileLayer = new ShapeFileFeatureLayer(@"..\..\AppData\buildings.shp");
            shapeFileLayer.RequireIndex = false;
            shapeFileLayer.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = AreaStyles.Swamp1;
            shapeFileLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;
            shapeFileLayer.Transparency = 150;
            layerOverlay.Layers.Add(shapeFileLayer);
            winformsMap1.Overlays.Add(layerOverlay);

            shapeFileLayer.Open();
            var extent = new RectangleShape(10.7199170366592, 59.9402407773361, 10.7239939943619, 59.9373600848541);
            winformsMap1.CurrentExtent = extent;

            //var geoCanvas = new GdiPlusGeoCanvas();
            //var bitmap = new Bitmap(760, 537);
            //geoCanvas.BeginDrawing(bitmap, extent, GeographyUnit.DecimalDegree);
            //shapeFileLayer.Draw(geoCanvas, new Collection<SimpleCandidate>());
            //geoCanvas.EndDrawing();
            //var worldFile = new WorldFile(extent, 760, 537);
            //var builder = new StringBuilder();
            //builder.AppendLine(worldFile.HorizontalResolution.ToString());
            //builder.AppendLine(worldFile.RotationColumn.ToString());
            //builder.AppendLine(worldFile.RotationRow.ToString());
            //builder.AppendLine(worldFile.VerticalResolution.ToString());
            //builder.AppendLine(worldFile.UpperLeftX.ToString());
            //builder.AppendLine(worldFile.UpperLeftY.ToString());
            //File.WriteAllText(@"..\..\AppData\export.tfw", builder.ToString());
            //bitmap.Save(@"..\..\AppData\export.tif");
            //bitmap.Dispose();

            winformsMap1.Refresh();
        }
    }
}
